        // Maintain an array of five mark values.
class StudentMarks {
        // Return the mark for the given assignment.
        // Return -1 if the assignment number is invalid.
    public double getMark(int assignment){
        if(validAssignment(assignment)){
            double[] marks = getMarks();
            return marks[assignment];
        }
        else{
            return -1;
        }
    }

        // Set the given mark for the given assignment.
        // Do nothing if the assignment number is invalid.
    public void setMark(int assignment,double mark){
        if(validAssignment(assignment)){
            double[] marks = getMarks();
            marks[assignment] = mark;
        }
    }

        // Return the index of the highest mark.
    public int getHighestMarkIndex(){
        double[] marks = getMarks();
        final int numMarks = marks.length;
        // Assume that the highest mark is the first.
        int highestIndex = 0;
        double highestSoFar = marks[0];
        for(int i = 1; i < numMarks; i++){
            if(marks[i] > highestSoFar){
                highestIndex = i;
                highestSoFar = marks[i];
            }
        }
        return highestIndex;
    }

        // Return how many assignments there are.
    public int getNumAssignments(){
        return numAssignments;
    }

        // Return true if the given assignment number is valid;
        // false otherwise.
    private boolean validAssignment(int assignment){
        return (assignment >= 0) && (assignment < numAssignments);
    }

    private double[] getMarks(){
        return marks;
    }

    private final int numAssignments = 5;
    private double[] marks = new double[numAssignments];
}
