import java.util.ArrayList;

    // Maintain a collection of Coin objects in an ArrayList.
class CoinCollection {
        // If player is not already in the collection, add a
        // new Coin. Otherwise, increase the count for the
        // existing coin.
    public void addToCollection(String player){
        // See if the player already exists.
        Coin coin = findCoin(player);
        if(coin == null){
            // Add a new one into the collection.
            coin = new Coin(player);
            getCoins().add(coin);
        }
        else{
            // Already in the collection.
            coin.addToCount(1);
        }
    }

        // Print the details of all coins in the collection
        // whose count is greater than 1.
    public void printDuplicates(){
        ArrayList collection = getCoins();
        final int size = collection.size();
        for(int i = 0; i < size; i++){
            Coin coin = (Coin) collection.get(i);
            if(coin.getCount() > 1){
                System.out.println(coin.toString());
            }
        }
    }

        // Reduce the count attribute by one of the Coin
        // whose name attribute matches the give argument.
        // Increase the count by one for the Coin whose name
        // matches the get attribute.
        // If a Coin does not already exist for the player
        // matching the get attribute, then a new Coin is
        // created and added to the collection.
    public void swap(String give, String get){
        // Make sure we have a coin to give.
        Coin givenCoin = findCoin(give);
        if(givenCoin != null){
            // See if we already have the other player.
            Coin getCoin = findCoin(get);
            if(getCoin == null){
                // We don't already have it.
                addToCollection(get);
            }
            else{
                getCoin.addToCount(1);
            }
            // Reduce the given coin's count. If it reaches
            // zero, as a result, remove it from the collection.
            givenCoin.addToCount(-1);
            if(givenCoin.getCount() <= 0){
                getCoins().remove(givenCoin);
            }
        }
    }

        // A method to show the current contents of the collection.
    public void printContents(){
        ArrayList collection = getCoins();
        final int size = collection.size();
        System.out.println("Contents");
        for(int i = 0; i < size; i++){
            Coin coin = (Coin) collection.get(i);
            System.out.println(coin.toString());
        }
        System.out.println();
    }

        // A method to find a coin with the given player's
        // name. Return null if a coin with that name is not found.
    private Coin findCoin(String playerName){
        ArrayList collection = getCoins();
        final int size = collection.size();
        for(int i = 0; i < size; i++){
            Coin coin = (Coin) collection.get(i);
            if(coin.getName().equals(playerName)){
                // Found it.
                return coin;
            }
        }
        // We failed to find the player.
        return null;
    }

    private ArrayList getCoins(){
        return coins;
    }

    private final ArrayList coins = new ArrayList();
}
