import java.util.LinkedList;

        // Maintain a changing collection of FurryFigure objects.
class FurryFigureCollection {
    public void addToCollection(FurryFigure figure){
        getFigures().add(figure);
    }

        // Print the descriptions of all animals with the
        // given type (case-insensitive).
    public void printDescriptions(String animalType){
        LinkedList collection = getFigures();
        final int size = collection.size();
        for(int i = 0; i < size; i++){
            FurryFigure animal = (FurryFigure) collection.get(i);
            // Check if it is of the required type.
            if(animalType.equalsIgnoreCase(animal.getType())){
                System.out.println(animal.getDescription());
            }
        }
    }

        // Calculate how much money was paid for all figures
        // in the collection.
    public int investment(){
        LinkedList collection = getFigures();
        final int size = collection.size();
        int total = 0;
        for(int i = 0; i < size; i++){
            FurryFigure animal = (FurryFigure) collection.get(i);
            total += animal.getPrice();
        }
        return total;
    }

        // Return a new list of FurryFigures whose descriptions
        // include the (case-insensitive) search string.
    public LinkedList findAll(String searchString){
        // Prepare a LinkedList to contain the found figures.
        LinkedList found = new LinkedList();
        LinkedList collection = getFigures();
        final int size = collection.size();

        // Perform all comparisons in lower-case, in order to provide.
        // the required case-insensitivity.
        searchString = searchString.toLowerCase();
        for(int i = 0; i < size; i++){
            FurryFigure animal = (FurryFigure) collection.get(i);
            // Force a lower-case comparison.
            String description = animal.getDescription().toLowerCase();
            if(description.indexOf(searchString) >= 0){
                found.add(animal);
            }
        }
        return found;
    }

    public void printCollection(){
        LinkedList collection = getFigures();
        final int size = collection.size();
        for(int i = 0; i < size; i++){
            FurryFigure animal = (FurryFigure) collection.get(i);
            System.out.println(animal.toString());
        }
    }

    private LinkedList getFigures(){
        return figures;
    }

    private final LinkedList figures = new LinkedList();
}
