import java.io.*;

        // Write the command line arguments to a DataOutputStream
        // and then read them back in via a DataInputStream.
class ArgumentEncoder {
    public static void main(String[] args){
        if(args.length > 0){
            try{
                final String filename = "arguments.bin";
                // Write out the command line arguments.
                DataOutputStream outputFile = new DataOutputStream(
                                        new FileOutputStream(filename));
                for(int i = 0; i < args.length; i++){
                    outputFile.writeUTF(args[i]);
                }

                // Read them back in.
                readBackArguments(filename);
            }
            catch(FileNotFoundException e){
                System.err.println("File not found: "+e.getMessage());
            }
            catch(IOException e){
                System.err.println("IO exception: "+e.getMessage());
            }
        }
        else{
            System.err.println("Usage: ArgumentEncoder arg ...");
        }
    }

    private static void readBackArguments(String filename)
                                                throws IOException {
        DataInputStream inputFile = null;
        try{
            inputFile = new DataInputStream(
                                    new FileInputStream("data.out"));
            String s = inputFile.readUTF();
            while(s != null){
                System.out.println("String read: "+s);
                s = inputFile.readUTF();
            }
            // Should not be reached. Loop terminates on
            // EOFException.
        }
        catch(FileNotFoundException e){
            System.err.println("File not found: "+e.getMessage());
        }
        catch(EOFException e){
            // Should be the end of the input file.
        }
        finally{
            if(inputFile != null){
                inputFile.close();
            }
        }
    }
}
