import java.io.*;
import java.util.Random;

        // Store or find a message in the file: hiddenword.bin
        // The address of the message is written as a long at
        // the start of the file.
class HiddenMessage {
    public static void main(String[] args) throws IOException {
        findMessage("hiddenword.bin");
    }

        // Locate the message.
    public static void findMessage(String filename) throws IOException {
        final RandomAccessFile file =
                        new RandomAccessFile(filename,"r");
        long where;
        file.seek(0L);
        where = file.readLong();
        if(where < file.length()){
            file.seek(where);
            String message = file.readUTF();
            System.out.println("The message is: "+message+" at "+where);
        }
        else{
            throw new IOException ("Where ("+where+") is outside the file: "+
                                  file.length());
        }
        file.close();
    }

        // Store a message at a random position within filename.
    public static void storeMessage(String filename) throws IOException {
        final int LettersInAlphabet = 26;
        final Random rand = new Random();
        final RandomAccessFile file =
                        new RandomAccessFile(filename,"rw");
        final int numChars = 4096;
        // Write random char values into the whole file.
        for(int i = 0; i < numChars; i++){
            int offset = rand.nextInt(LettersInAlphabet);
            file.writeChar('a'+offset);
        }

        final String message = "serendipity";

        // Generate a random location for the string. Be cautious about
        // making sure it will fit before the end of the file and
        // won't be right at the start of the file.
        long where = rand.nextInt((int)file.length()/2) + 200;

        // Write its position at the start of the file.
        file.seek(0L);
        file.writeLong(where);
        file.seek(where);
        file.writeUTF(message);
        file.close();
    }
}
