import java.io.*;
import java.util.*;

        // Read a file, sort its lines, and write the sorted version
        // to a new file. The input and output files are passed
        // as command line arguments.
class SortFile {
    public static void main(String[] args) throws IOException {
        if(args.length == 2){
            BufferedReader reader = null;
            BufferedWriter writer = null;
            try{
                // Open the input and output files.
                reader = new BufferedReader(new FileReader(args[0]));
                writer = new BufferedWriter(new FileWriter(args[1]));
                // Storage for the lines.
                LinkedList lines = new LinkedList();
                // Read the file's contents.
                String line = reader.readLine();
                while(line != null){
                    lines.add(line);
                    line = reader.readLine();
                }
                // Sort the lines.
                Collections.sort(lines);
                // Write the sorted version.
                Iterator it = lines.iterator();
                while(it.hasNext()){
                    writer.write((String) it.next());
                    writer.newLine();
                }
            }
            catch(FileNotFoundException e){
                System.err.println("File not found: "+e.getMessage());
            }
            catch(IOException e){
                System.err.println("IO error: "+e.getMessage());
            }
            finally{
                if(reader != null){
                    reader.close();
                }
                if(writer != null){
                    writer.close();
                }
            }
        }
        else{
            System.err.println("Usage: java SortFile infile outfile");
        }
    }
}
