        // Keep a set of details on a particular team:
        //     a name, the team's coach, and their home venue.
class TeamDetails implements Comparable {
    public TeamDetails(String name, String coach, String venue){
        setName(name);
        setCoach(coach);
        setVenue(venue);
    }

    public String getName(){
        return name;
    }

    public String getCoach(){
        return coach;
    }

    public String getVenue(){
        return venue;
    }

    public int getPoints(){
        return points;
    }

        // Allow points to be set, but only if non-negative.
    public void setPoints(int p){
        if(p >= 0){
            points = p;
        }
    }

        // Sort TeamDetails so that higher points come before
        // lower points. Teams with equal points are sorted
        // on a comparison of their names.
    public int compareTo(Object o) throws ClassCastException {
        // Push null objects to the end.
        if(o == null){
            return -1;
        }
        else{
            // ClassCastException possible here.
            TeamDetails other = (TeamDetails) o;
            int pointsDifference = other.getPoints()-getPoints();
            if(pointsDifference != 0){
                return pointsDifference;
            }
            else{
                return getName().compareTo(other.getName());
            }
        }
    }

    private void setName(String n){
        name = n;
    }

    private void setCoach(String c){
        coach = c;
    }

    private void setVenue(String v){
        venue = v;
    }

    // The team's basic attributes.
    private String name, coach, venue;
    // How many points this team has.
    private int points = 0;
}
