        // An immutable card object. It retains the same suit
        // and value throughout its life.
class SuitedCard implements Comparable {
    public SuitedCard(int suit,int value){
        this.suit = suitNames[suit];
        this.value = value;
    }

        // Order primarily on suit. Cards of the same suit
        // are ordered in decreasing value.
    public int compareTo(Object o)
                throws ClassCastException, RuntimeException{
        if(o == null){
            throw new RuntimeException("Null passed to compareTo.");
        }
        else{
            // ClassCastException possible here.
            SuitedCard other = (SuitedCard) o;
            int suitDifference = getSuit().compareTo(other.getSuit());
            if(suitDifference == 0){
                return other.getValue()-getValue();
            }
            else{
                return suitDifference;
            }
        }
    }

    public String toString(){
        return "Suit: "+getSuit()+" Value: "+getValue();
    }

    public String getSuit(){
        return suit;
    }

    public int getValue(){
        return value;
    }

        // Provide access to the suit names.
    public static String[] getSuitNames(){
        return suitNames;
    }

    // The names for the four suits.
    private final static String[] suitNames = {
        "Spades", "Hearts", "Diamonds", "Clubs",
    };

    // The suit and value of this card.
    private final String suit;
    private final int value;
}
