import java.util.*;

class Plotter {
        // Plot count pixels of color, starting at x,y and
        // moving right horizontally.
    public void plot(int x, int y, int count, int color){
        // Save a copy of the data.
        getPoints().add(new DataPoint(x,y,count,color));
    }

        // Output the arguments to each previous call to plot.
    public void dumpData(){
        Iterator it = getPoints().iterator();
        while(it.hasNext()){
            DataPoint point = (DataPoint) it.next();
            System.out.println(point);
        }
    }

        // Store details of each point plotted.
    protected class DataPoint {
        public DataPoint(int x, int y, int count,int color){
            this.x = x;
            this.y = y;
            this.count = count;
            this.color = color;
        }

        int getX(){
            return x;
        }

        public int getY(){
            return y;
        }

        public int getCount(){
            return count;
        }

        public int getColor(){
            return color;
        }

        public String toString(){
            return getX()+" "+getY()+" "+getCount()+" "+getColor();
        }

        private final int x, y, count, color;
    }

    protected LinkedList getPoints(){
        return points;
    }

    // Storage for the DataPoints.
    private LinkedList points = new LinkedList();
}
